zoukankan      html  css  js  c++  java
  • HDU 4770 Lights Against DudelyLights

    Lights Against Dudely

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 525    Accepted Submission(s): 157

    Problem Description
    Harry: "But Hagrid. How am I going to pay for all of this? I haven't any money."
    Hagrid: "Well there's your money, Harry! Gringotts, the wizard bank! Ain't no safer place. Not one. Except perhaps Hogwarts."
    — Rubeus Hagrid to Harry Potter.
      Gringotts Wizarding Bank is the only bank of the wizarding world, and is owned and operated by goblins. It was created by a goblin called Gringott. Its main offices are located in the North Side of Diagon Alley in London, England. In addition to storing money and valuables for wizards and witches, one can go there to exchange Muggle money for wizarding money. The currency exchanged by Muggles is later returned to circulation in the Muggle world by goblins. According to Rubeus Hagrid, other than Hogwarts School of Witchcraft and Wizardry, Gringotts is the safest place in the wizarding world.
      The text above is quoted from Harry Potter Wiki. But now Gringotts Wizarding Bank is not safe anymore. The stupid Dudley, Harry Potter's cousin, just robbed the bank. Of course, uncle Vernon, the drill seller, is behind the curtain because he has the most advanced drills in the world. Dudley drove an invisible and soundless drilling machine into the bank, and stole all Harry Potter's wizarding money and Muggle money. Dumbledore couldn't stand with it. He ordered to put some magic lights in the bank rooms to detect Dudley's drilling machine. The bank can be considered as a N × M grid consisting of N × M rooms. Each room has a coordinate. The coordinates of the upper-left room is (1,1) , the down-right room is (N,M) and the room below the upper-left room is (2,1)..... A 3×4 bank grid is shown below:

    Some rooms are indestructible and some rooms are vulnerable. Dudely's machine can only pass the vulnerable rooms. So lights must be put to light up all vulnerable rooms. There are at most fifteen vulnerable rooms in the bank. You can at most put one light in one room. The light of the lights can penetrate the walls. If you put a light in room (x,y), it lights up three rooms: room (x,y), room (x-1,y) and room (x,y+1). Dumbledore has only one special light whose lighting direction can be turned by 0 degree,90 degrees, 180 degrees or 270 degrees. For example, if the special light is put in room (x,y) and its lighting direction is turned by 90 degrees, it will light up room (x,y), room (x,y+1 ) and room (x+1,y). Now please help Dumbledore to figure out at least how many lights he has to use to light up all vulnerable rooms.
    Please pay attention that you can't light up any indestructible rooms, because the goblins there hate light.

     
    Input
    There are several test cases.
    In each test case:
    The first line are two integers N and M, meaning that the bank is a N × M grid(0<N,M <= 200).
    Then a N×M matrix follows. Each element is a letter standing for a room. '#' means a indestructible room, and '.' means a vulnerable room.
    The input ends with N = 0 and M = 0
     
    Output
    For each test case, print the minimum number of lights which Dumbledore needs to put.
    If there are no vulnerable rooms, print 0.
    If Dumbledore has no way to light up all vulnerable rooms, print -1.
     
    Sample Input
    2 2 ## ## 2 3 #.. ..# 3 3 ### #.# ### 0 0
     
    Sample Output
    0 2 -1
     
    Source
    2013 Asia Hangzhou Regional Contest
    解题思路:杭州的A题,看到网上很多大牛用状态压缩来写,表示YM,虽然我也想到了压缩,不过这一题不用压缩就能写,所以我没用压缩,直接爆搜加优化就可以了。详见代码
    #include<iostream>
    #include<cstdio>
    #include<cstring>
    #define N 205
    using namespace std;
    char maze[N][N];
    int x[20],y[20],visit[N][N],ans;
    bool vis[N][N];
    void recover(int k)
    {
    	int i;
    	for(i=0;i<k;i++)
    		visit[x[i]][y[i]]=0,vis[x[i]][y[i]]=false;
    }
    void dfs(int cnt,int now,int k,int dep)
    {
    	if(cnt>=ans-1&&now!=k||cnt>dep)
    		//优化3:已经放的灯数比现在的答案大就直接返回
    		return ;
    	if(now==k)
    	{
    		ans=min(ans,cnt);
    		return ;
    	}
    	for(int i=0;i<k;i++)
    	{
    		int flag1=0,flag2=0,flag3=0,flag=0;
    		if(maze[x[i]-1][y[i]]!='#'&&maze[x[i]][y[i]+1]!='#'&&!vis[x[i]][y[i]]&&(visit[x[i]][y[i]]==0||(visit[x[i]][y[i]+1]==0&&maze[x[i]][y[i]+1]=='.')||(visit[x[i]-1][y[i]]==0&&maze[x[i]-1][y[i]]=='.')))
    			//vis数组记录该位置放灯了没,visit数组记录该位置是否被照亮,优化2:放下一个灯的时候至少能多照亮一个位置才放灯
    		{
    			if(visit[x[i]][y[i]]==0)
    				flag1=1;
    			if(visit[x[i]][y[i]+1]==0)
    				flag2=1;
    			if(visit[x[i]-1][y[i]]==0)
    				flag3=1;
    			flag=flag1+flag2+flag3;
    			visit[x[i]][y[i]]++;
    			visit[x[i]-1][y[i]]++;
    			visit[x[i]][y[i]+1]++;
    			vis[x[i]][y[i]]=true;
    			if(maze[x[i]-1][y[i]]=='.'&&maze[x[i]][y[i]+1]=='.')
    			    dfs(cnt+1,now+flag,k,dep);
    			else if(maze[x[i]-1][y[i]]=='.')
    			    dfs(cnt+1,flag1+flag3+now,k,dep);
    			else if(maze[x[i]][y[i]+1]=='.')
    				dfs(cnt+1,flag1+flag2+now,k,dep);
    			else
    				dfs(cnt+1,flag1+now,k,dep);
    			visit[x[i]][y[i]]--;
    			visit[x[i]-1][y[i]]--;
    			visit[x[i]][y[i]+1]--;
    			vis[x[i]][y[i]]=false;
    		}
    	}
    	return ;
    }
    int main()
    {
    	int m,n,i,j,k,t;
    	bool flag;
    	while(scanf("%d%d",&m,&n),m+n)
    	{
    		flag=true;
    		k=t=0;
    		ans=100;
    		getchar();
    		for(i=0;i<=m+1;i++)
    			for(j=0;j<=n+1;j++)
    			{
    				maze[i][j]='@';
    				visit[i][j]=0;
    				vis[i][j]=false;
    			}
    		for(i=1;i<=m;i++)
    		{
    			for(j=1;j<=n;j++)
    			{
    				scanf("%c",&maze[i][j]);
    				if(maze[i][j]=='.')
    					x[k]=i,y[k++]=j;
    			}
    			getchar();
    		}
    		if(k==0)
    		{
    			printf("0
    ");
    			continue;
    		}
    		int Min=k%3?k/3+1:k/3;//优化1:n个可以放灯的点至少需要[n/3]展灯
    		for(i=0;i<k;i++)
    		{
    			if(maze[x[i]-1][y[i]]!='#'&&maze[x[i]][y[i]+1]!='#')
    			{
    				visit[x[i]][y[i]]++;
    				visit[x[i]-1][y[i]]++;
    				visit[x[i]][y[i]+1]++;
    				vis[x[i]][y[i]]=true;
    				if(maze[x[i]-1][y[i]]=='@'&&maze[x[i]][y[i]+1]=='@')
    				{
    					for(j=Min;j<=min(ans,k);j++)
    					    dfs(1,1,k,j);
    				}
    				else if(maze[x[i]-1][y[i]]=='@'||maze[x[i]][y[i]+1]=='@')
    				{
    					for(j=Min;j<=min(ans,k);j++)
    					    dfs(1,2,k,j);
    				}
    			    else
    				{
    					for(j=Min;j<=min(ans,k);j++)
    					    dfs(1,3,k,j);
    				}
    			}
    			recover(k);
    			flag=true;
    			if(maze[x[i]][y[i]+1]!='#'&&maze[x[i]+1][y[i]]!='#')
    			{
    				visit[x[i]][y[i]]++;
    				visit[x[i]+1][y[i]]++;
    				visit[x[i]][y[i]+1]++;
    				vis[x[i]][y[i]]=true;
    				if(maze[x[i]+1][y[i]]=='@'&&maze[x[i]][y[i]+1]=='@')
    			    {
    					for(j=Min;j<=min(ans,k);j++)
    					    dfs(1,1,k,j);
    				}
    				else if(maze[x[i]+1][y[i]]=='@'||maze[x[i]][y[i]+1]=='@')
    				{
    					for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,2,k,j);
    				}
    				else
    				{
    					for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,3,k,j);
    				}
    			}
    			recover(k);
    			flag=true;
    			if(maze[x[i]+1][y[i]]!='#'&&maze[x[i]][y[i]-1]!='#')
    			{
    				visit[x[i]][y[i]]++;
    				visit[x[i]+1][y[i]]++;
    				visit[x[i]][y[i]-1]++;
    				vis[x[i]][y[i]]=true;
    				if(maze[x[i]+1][y[i]]=='@'&&maze[x[i]][y[i]-1]=='@')
    			    {
    					for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,1,k,j);
    				}
    				else if(maze[x[i]+1][y[i]]=='@'||maze[x[i]][y[i]-1]=='@')
    				{
    					for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,2,k,j);
    				}
    				else
    				{
    					for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,3,k,j);
    				}
    				
    			}
    			recover(k);
    			flag=true;
    			if(maze[x[i]][y[i]-1]!='#'&&maze[x[i]-1][y[i]]!='#')
    			{
    				visit[x[i]][y[i]]++;
    				visit[x[i]-1][y[i]]++;
    				visit[x[i]][y[i]-1]++;
    				vis[x[i]][y[i]]=true;
    				if(maze[x[i]-1][y[i]]=='@'&&maze[x[i]][y[i]-1]=='@')
    				{
                        for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,1,k,j);
    				}
    				else if(maze[x[i]-1][y[i]]=='@'||maze[x[i]][y[i]-1]=='@')
    				{
    				    for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,2,k,j);
    				}
    				else
    				{
    					for(j=Min;j<=min(ans,k);j++)
    				        dfs(1,3,k,j);
    				}
    			}
    			recover(k);
    			flag=true;
    		}
    		if(ans==100)
    			printf("-1
    ");
    		else
    			printf("%d
    ",ans);
    	}
    	return 0;
    }


  • 相关阅读:
    Spark系列文章(三):搭建Spark开发环境IDEA
    MAC下搭建Hadoop运行环境
    Spark系列文章(二):Spark运行环境构建
    Spark系列文章(一):Spark初识
    Mac配置Maven及IntelliJ IDEA Maven配置
    《VC++深入详解》学习笔记 第十八章 ActiveX控件
    《VC++深入详解》学习笔记 第十七章 进程间通信
    Git 常用指令
    BAT脚本
    让Git的输出更友好: 多种颜色和自定义log格式
  • 原文地址:https://www.cnblogs.com/james1207/p/3424208.html
Copyright © 2011-2022 走看看